function love.load()
    love.graphics.setBackgroundColor(0,0,0)
    love.graphics.setNewFont(24)
    love.window.setMode( 800, 600, {fullscreen=false} )
    love.window.setTitle( "Simple Collision" )
    love.mouse.setVisible( false )
    music = love.audio.newSource("music/timers.ogg")
    music:setLooping(true)
    x = 0 
    y = 0
    finish = false
    start = true
    over = false
    lives = 3
    levelstart = false
    fullscreen = false
    musicon = true
    love.audio.play(music)
end

function love.keyreleased(key)
    if key == "escape" then
        love.event.push("quit")
    end
    if key == "f" then
        fullscreen = not fullscreen
        love.window.setFullscreen(fullscreen)
    end
    if key == "m" then
        if musicon then
            love.audio.stop(music)
            musicon = false
        else
            love.audio.play(music)
            musicon = true
        end
    end
    if key == "space" and over then
        level = 0
        lives = 3
        loadLevel()
    elseif key == "space" and start then
        level = 0
        loadLevel()
    elseif key == "space" and levelstart then
        levelstart = false
    elseif key == "space" and dead then
        level = level - 1
        loadLevel()
    end
end

function love.update(dt)
    if not levelstart and not start and not over and not dead then
        if love.keyboard.isDown("right") then
            x = x + (100 * dt)
            if x > mapWidth then
                x = x - (100 * dt)
            end
        end
        if love.keyboard.isDown("left") then
            x = x - (100 * dt)
            if x < 0 then
                x = x + (100 * dt)
            end
        end
        if love.keyboard.isDown("up") then
            y = y - (100 * dt)
            if y < 0 then
                y = y + (100 * dt)
            end
        end
        if love.keyboard.isDown("down") then
            y = y + (100 * dt)
            if y > mapHeight then
                y = y - (100 * dt)
            end
        end
        for _, box in ipairs(boxes) do
            if box[4] then
                if box[3] == "1" then
                    timeBlue = timeBlue - dt
                elseif box[3] == "2" then
                    timeRed = timeRed - dt
                elseif box[3] == "3" then
                    timeGreen = timeGreen - dt
                end
            end
            if CheckCollision(x + 15, y + 15, 1, 1, box[1] + 1, box[2] + 1, 31, 31) then
                if box[3] == "4" then
                    loadLevel()
                else
                    box[4] = true
                end
            else
                box[4] = false
            end
        end
        if math.ceil(timeBlue) == 0 or math.ceil(timeRed) == 0 or math.ceil(timeGreen) == 0 then
            lives = lives - 1
            dead = true
            if lives == 0 then
                dead = false
                over = true
            end
        end
    end
end

function love.draw()
    if not over and not start and not dead and not finish then
        for _, box in ipairs(boxes) do
            if box[3] == "1" then
                love.graphics.setColor(math.ceil((100 * timeBlue) / timeB), math.ceil((100 * timeBlue) / timeB), math.ceil((255 * timeBlue) / timeB))
                love.graphics.rectangle("fill", box[1] + 33, box[2] + 33, 31, 31)
            end
            if box[3] == "2" then
                love.graphics.setColor(math.ceil((255 * timeRed) / timeR), math.ceil((100 * timeRed) / timeR), math.ceil((100 * timeRed) / timeR))
                love.graphics.rectangle("fill", box[1] + 33, box[2] + 33, 31, 31)
            end
            if box[3] == "3" then
                love.graphics.setColor(math.ceil((100 * timeGreen) / timeG), math.ceil((255 * timeGreen) / timeG), math.ceil((100 * timeGreen) / timeG))
                love.graphics.rectangle("fill", box[1] + 33, box[2] + 33, 31, 31)
            end
            if box[3] == "4" then
                love.graphics.setColor(255, 0, 255)
                love.graphics.rectangle("fill", box[1] + 33, box[2] + 33, 31, 31)
            end
            if box[4] then
                love.graphics.setColor(255, 255, 255, 100)
                love.graphics.rectangle("fill", box[1] + 32, box[2] + 32, 32, 32)
            end
        end
        for i = 1, lives do
            love.graphics.setColor(255, 0, 255)
            love.graphics.circle("fill", 764 - (i * 32), 32, 8)
        end
        love.graphics.setColor(255, 0, 255)
        love.graphics.circle("fill", x + 48, y + 48, 8)
        love.graphics.setNewFont(24)
        love.graphics.setColor(100, 100, 255)
        if math.ceil(timeBlue) > 0 then
            love.graphics.print(math.ceil(timeBlue), 700, 64)
        else
            love.graphics.print("---", 700, 64)
        end
            love.graphics.setColor(255, 100, 100)
        if math.ceil(timeRed) > 0 then
            love.graphics.print(math.ceil(timeRed), 700, 94)
        else
            love.graphics.print("---", 700, 84)
        end
        love.graphics.setColor(100, 255, 100)
        if math.ceil(timeGreen) > 0 then
            love.graphics.print(math.ceil(timeGreen), 700, 124)
        else
            love.graphics.print("---", 700, 104)
        end
        if levelstart then
            love.graphics.setColor(255, 255, 255)
            love.graphics.print("Press Space when ready.", 250, 400)
        end
    end
    if over then
        love.graphics.setColor(255, 255, 255)
        love.graphics.print("Game Over.\nPress Space to start again.", 250, 400)
    end
    if start then
        love.graphics.setColor(255, 0, 255)
        love.graphics.print("timers", 280, 220)
        love.graphics.setColor(255, 255, 255)
        love.graphics.print("by O. Bahri Gordebak", 400, 250)
        love.graphics.setColor(255, 100, 100)
        love.graphics.rectangle("fill", 400, 216, 31, 31)
        love.graphics.setColor(100, 255, 100)
        love.graphics.rectangle("fill", 432, 216, 31, 31)
        love.graphics.setColor(100, 100, 255)
        love.graphics.rectangle("fill", 464, 216, 31, 31)
        love.graphics.setColor(255, 0, 255)
        love.graphics.rectangle("fill", 496, 216, 31, 31)
        love.graphics.setColor(255,255,255)
        love.graphics.print("Press Space to start.\nPress F to toggle fullscreen.\nPress M to toggle music.\nPress Escape to quit.", 250, 400)
    end
    if finish then
        love.graphics.setColor(255, 0, 255)
        love.graphics.print("timers", 280, 220)
        love.graphics.setColor(255, 255, 255)
        love.graphics.print("by O. Bahri Gordebak", 400, 250)
        love.graphics.setColor(255, 100, 100)
        love.graphics.rectangle("fill", 400, 216, 31, 31)
        love.graphics.setColor(100, 255, 100)
        love.graphics.rectangle("fill", 432, 216, 31, 31)
        love.graphics.setColor(100, 100, 255)
        love.graphics.rectangle("fill", 464, 216, 31, 31)
        love.graphics.setColor(255, 0, 255)
        love.graphics.rectangle("fill", 496, 216, 31, 31)
        love.graphics.setColor(255,255,255)
        love.graphics.print("Yay!\nYou finished this little game.\nPress Escape to exit.", 250, 400)
    end
    if dead then
        love.graphics.setColor(255, 255, 255)
        love.graphics.print("Oops, you lost a life!\nPress Space to try again.", 250, 400)
    end
end

function loadLevel()
    boxes = {}
    over = false
    start = false
    levelstart = true
    dead = false
    level = level + 1
    if level == 11 then
        finish = true
    else
        love.filesystem.load("maps/level"..level..".lua")()
    end
end

function newMap(tileString)
    rowIndex,bc = 1,0
    for row in tileString:gmatch("[^\n]+") do
        columnIndex = 1
        for character in row:gmatch(".") do
            if character == "1" then
                bc = bc + 1
                boxes[bc] = { (columnIndex - 1)*32, (rowIndex - 1)*32, "1", false }
            end
            if character == "2" then
                bc = bc + 1
                boxes[bc] = { (columnIndex - 1)*32, (rowIndex - 1)*32, "2", false }
            end
            if character == "3" then
                bc = bc + 1
                boxes[bc] = { (columnIndex - 1)*32, (rowIndex - 1)*32, "3", false }
            end
            if character == "4" then
                bc = bc + 1
                boxes[bc] = { (columnIndex - 1)*32, (rowIndex - 1)*32, "4", false }
            end
            columnIndex = columnIndex + 1
        end
        rowIndex=rowIndex+1
    end
    mapWidth = (columnIndex - 2) * 32
    mapHeight = (rowIndex - 2) * 32
    timeR = timeRed
    timeG = timeGreen
    timeB = timeBlue
end

function CheckCollision(ax1,ay1,aw,ah, bx1,by1,bw,bh)
    local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
    return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end
